:- module(_,_,[functions,assertions]).
:- use_module(library(terms),[atom_concat/2]).

:- reexport('../SETTINGS_COMMON').

htmlindex_headfile := ~atom_concat([~src,'/doc/common/CiaoHead.html']).
htmlindex_tailfile := ~atom_concat([~src,'/doc/common/CiaoTail.html']).
infodir_headfile   := ~atom_concat([~src,'/doc/common/CiaoHead.info']).
infodir_tailfile   := ~atom_concat([~src,'/doc/common/CiaoTail.info']).

mainfile := 'ciao.pl'.

filepath(A) :- member(A1,~filepaths),atom_concat(A1,A).
filepaths([
	[CiaoAbsSrcApp],
	[CiaoAbsSrcApp,'/doc/common'],
	[CiaoAbsSrcApp,'/doc/reference'],
	[CiaoAbsSrcApp,'/shell'],
	[CiaoAbsSrcApp,'/ciaoc'],
	[CiaoAbsSrcApp,'/engine'],
	[CiaoAbsSrcApp,'/emacs-mode'],
	[CiaoAbsSrcApp,'/etc'],
	[CiaoAbsSrcApp,'/library/pillow/dist/doc']]) :-
 src(CiaoAbsSrcApp).

systempath(A) :- member(A1,~systempaths),atom_concat(A1,A).
systempaths([
	[CiaoAbsSrcApp,'/lib'],
	[CiaoAbsSrcApp,'/lib/compiler'],
	[CiaoAbsSrcApp,'/lib/debugger'],
	[CiaoAbsSrcApp,'/lib/engine'],
	[CiaoAbsSrcApp,'/lib/assertions'],
	[CiaoAbsSrcApp,'/lib/metatypes'],
	[CiaoAbsSrcApp,'/lib/regtypes'],
	[CiaoAbsSrcApp,'/lib/foreign_interface'],
	[CiaoAbsSrcApp,'/library'],
	[CiaoAbsSrcApp,'/library/actmods'],
	[CiaoAbsSrcApp,'/library/agent'],
	[CiaoAbsSrcApp,'/library/andorra'],
	[CiaoAbsSrcApp,'/library/andprolog'],
	[CiaoAbsSrcApp,'/library/argnames'],
	[CiaoAbsSrcApp,'/library/assertions'],
	[CiaoAbsSrcApp,'/library/bf'],
	[CiaoAbsSrcApp,'/library/builtintables'],
	[CiaoAbsSrcApp,'/library/byrdbox'],
	[CiaoAbsSrcApp,'/library/class'],
	[CiaoAbsSrcApp,'/library/class'],
	[CiaoAbsSrcApp,'/library/class/examples'],
	[CiaoAbsSrcApp,'/library/clpq'],
	[CiaoAbsSrcApp,'/library/clpr'],
	[CiaoAbsSrcApp,'/library/concurrency'],
	[CiaoAbsSrcApp,'/library/det_hook'],
	[CiaoAbsSrcApp,'/library/emacs'],
	[CiaoAbsSrcApp,'/library/factsdb'],
	[CiaoAbsSrcApp,'/library/file_locks'],
	[CiaoAbsSrcApp,'/library/fly'],
	[CiaoAbsSrcApp,'/library/freeze'],
	[CiaoAbsSrcApp,'/library/functions'],
	[CiaoAbsSrcApp,'/library/fuzzy'],
	[CiaoAbsSrcApp,'/library/graphs'],
	[CiaoAbsSrcApp,'/library/graphs'],
	[CiaoAbsSrcApp,'/library/id'],
	[CiaoAbsSrcApp,'/library/indexer'],
	[CiaoAbsSrcApp,'/library/interface'],
	[CiaoAbsSrcApp,'/library/javall'],
	[CiaoAbsSrcApp,'/library/javall/Figs'],
	[CiaoAbsSrcApp,'/library/librowser'],
	[CiaoAbsSrcApp,'/library/math'],
	[CiaoAbsSrcApp,'/library/make'],
	[CiaoAbsSrcApp,'/library/objects'],
	[CiaoAbsSrcApp,'/library/objects/examples'],
	[CiaoAbsSrcApp,'/library/persdb'],
	[CiaoAbsSrcApp,'/library/persdb/examples'],
	[CiaoAbsSrcApp,'/library/persdb_sql_common'],
	[CiaoAbsSrcApp,'/library/persdb_mysql'],
	[CiaoAbsSrcApp,'/library/persdb_odbc'],
	[CiaoAbsSrcApp,'/library/pillow'],
	[CiaoAbsSrcApp,'/library/random'],
	[CiaoAbsSrcApp,'/library/remote'],
	[CiaoAbsSrcApp,'/library/sockets'],
	[CiaoAbsSrcApp,'/library/symfnames'],
	[CiaoAbsSrcApp,'/library/tcltk'],
	[CiaoAbsSrcApp,'/library/tcltk_obj'],
	[CiaoAbsSrcApp,'/library/tracing'],
	[CiaoAbsSrcApp,'/library/when'],
	[CiaoAbsSrcApp,'/library/xrefs'],
	[CiaoAbsSrcApp,'/library/xrefs/doc'],
	[CiaoAbsSrcApp,'/contrib'],
	[CiaoAbsSrcApp,'/contrib/time_analyzer'],
	[CiaoAbsSrcApp,'/contrib/tester'],
	[CiaoAbsSrcApp,'/contrib/modtester'],
	[CiaoAbsSrcApp,'/contrib/gnuplot'],
	[CiaoAbsSrcApp,'/contrib/ddlist'],
	[CiaoAbsSrcApp,'/contrib/chartlib'],
	[CiaoAbsSrcApp,'/contrib/fd'],
	[CiaoAbsSrcApp,'/contrib/mycin'],
	[CiaoAbsSrcApp,'/contrib/provrml'],
	[CiaoAbsSrcApp,'/contrib/xdr_handle'],
	[CiaoAbsSrcApp,'/contrib/xml_path/doc']]) :-
 src(CiaoAbsSrcApp).

component(A) :- member(A,~components).
components := [
%GetStarted
	    'GetStartUnix.pl',
	    'GetStartWin32.pl',
%DevEnv
	'DevEnv.pl',
	    'ciaoc.pl',
	    'ciaosh_doc.pl',
	    'debugger_doc.pl',
	        'debugger.pl',
	    'ciao-shell.pl',
	    'libpaths.pl',
	    'CiaoMode.pl',
%Builtins/RefComponents
	'Builtins.pl',
	    'modules.pl',
	    'loading_code.pl',
	    'basiccontrol.pl',
	    'builtin_directives.pl',
	    'basic_props.pl',
	    'term_typing.pl',
	    'term_basic.pl',
	    'term_compare.pl',
	    'atomic_basic.pl',
	    'arithmetic.pl',
	    'streams_basic.pl',
	    'io_basic.pl',
	    'exceptions.pl',
	    'prolog_flags.pl',
	    'data_facts.pl',
	    'syntax_extensions.pl',
	    'io_aux.pl',
	    'attributes.pl',
	    'system_info.pl',
%IsoProlog
	'IsoProlog.pl',
	    'iso_doc.pl',
	    'aggregates.pl',
	    'dynamic.pl',
	    'read.pl',
	    'write.pl',
	    'operators.pl',
	    'iso_byte_char.pl',
	    'iso_misc.pl',
	    'iso_incomplete.pl',
%ClassicProlog
	'ClassicProlog.pl',
	    'classic_doc.pl',
	    'dcg_doc.pl',
	        'dcg_expansion.pl',
	    'lists.pl',
	    'sort.pl',
	    'dict.pl',
	    'strings.pl',
	    'format.pl',
	    'dec10_io.pl',
	    'ttyout.pl',
	    'compiler.pl',
	    'old_database.pl',
	    'runtime_ops_doc.pl',
	    'between.pl',
%AnnotatedProlog
	'AnnotatedProlog.pl',
	    'assertions_doc.pl',
	    'assertions_props.pl',
	    'regtypes_doc.pl',
	    'native_props.pl',
	    'isomodes_doc.pl',
	    'basicmodes_doc.pl',
	    'rtchecks_doc.pl',
%MiscProlog
	'MiscProlog.pl',
	    'streams.pl',
	    'io_alias_redirection.pl',
	    'system.pl',
	    'prolog_sys.pl',
	    'atom2term.pl',
	    'ctrlcclean.pl',
	    'errhandle.pl',
	    'fastrw.pl',
	    'filenames.pl',
	    'symfnames.pl',
	    'file_utils.pl',
	    'file_locks.pl',
	    'terms.pl',
	    'terms_check.pl',
	    'terms_vars.pl',
	    'messages.pl',
	    'pretty_print.pl',
	    'assrt_write.pl',
	    'librowser.pl',
	    'expansion_tools.pl',
	    'concurrency.pl',
	    'conc_aggregates.pl',
	    'sockets.pl',
	    'sockets_io.pl',
	    'make_doc.pl',
	    'make_rt.pl',
	    'system_extra.pl',
%ExtendProlog
	'ExtendProlog.pl',
	    'pure_doc.pl',
	    'indexer_doc.pl',
	    'hiord_rt.pl',
	    'hiordlib.pl',
	    'argnames_doc.pl',
	    'functions_doc.pl',
	    'global.pl',
	    'andprolog_doc.pl',
	    'andorra_doc.pl',
	    'det_hook_rt.pl',
	    'odd.pl',
	    'freeze.pl',
	    'when.pl',
	    'actmods_doc.pl',
	    'bf_doc.pl',
	    'id_doc.pl',
	    'clpq_doc.pl',
	    'clpr_doc.pl',
	    'fuzzy_doc.pl',
	    'ociao_doc.pl',
	        'class_doc.pl',
		'objects_doc.pl',
		'objects_rt.pl',
	    'remote_doc.pl',
%Interfaces
	'Interfaces.pl',
	    'foreign_interface_doc.pl',
	    'foreign_interface_properties.pl',
	    'foreign_compilation.pl',
	    'build_foreign_interface.pl',
	    'davinci.pl',
	    'tcltk.pl',
	        'tcltk_low_level.pl',
	    'window_class_doc.pl',
	        'widget_class_doc.pl',
		    'menu_class_doc.pl',
		    'canvas_class_doc.pl',
		    'button_class_doc.pl',
		    'checkbutton_class_doc.pl',
		    'radiobutton_class_doc.pl',
		    'entry_class_doc.pl',
		    'label_class_doc.pl',
		    'menubutton_class_doc.pl',
		    'menu_entry_class_doc.pl',
	        'shape_class_doc.pl',
		    'arc_class_doc.pl',
		    'oval_class_doc.pl',
		    'poly_class_doc.pl',
		    'line_class_doc.pl',
		    'text_class_doc.pl',
	    'pillow_doc.pl',
	        'html.pl',
		'http.pl',
		'pillow_types.pl',
	    'persdbrt.pl',
	        'Examples.pl',
	    'factsdb_rt.pl',
	    'persdbrt_mysql.pl',
	        'pl2sql.pl',
		'mysql_client.pl',
		'db_client_types.pl',
		'sqltypes.pl',
		'persdbtr_sql.pl',
		'pl2sqlinsert.pl',
	    'javart.pl',
	        'jtopl.pl',
		'javasock.pl',
	    'emacs.pl',
	    'linda.pl',
%ADTs
	'ADTs.pl',
	    'arrays.pl',
	    'counters.pl',
	    'idlists.pl',
	    'numlists.pl',
	    'patterns.pl',
	    'graphs.pl',
	        'ugraphs.pl',
		'wgraphs.pl',
		'lgraphs.pl',
	    'queues.pl',
	    'random.pl',
	    'sets.pl',
	    'vndict.pl',
%Ciao-utilities
	'ciao-utilities.pl',
	    'cleandirs.pl',
	    'fileinfo.pl',
	    'viewpo.pl',
	    'xrefs_doc.pl',
	    'callgraph.pl',
	    'get_deps.pl',
	    'pldiff.pl',
	    'lpmake.pl',
	    'ciao_get_arch_doc.pl',
	    'compiler_output.pl',
	    'auto_compile_ciao_doc.pl',
	    'collect_modules_doc.pl',
%Contrib
	'Contrib.pl',
	    'mycin_doc.pl',
		'chartlib.pl',
		'fd_doc.pl',
		'xdr_handle.pl',
		'xml_path_doc.pl',
		'bltclass.pl',
		'chartlib_errhandle.pl',
		'color_pattern.pl',
		'genbar1.pl',
		'genbar2.pl',
		'genbar3.pl',
		'genbar4.pl',
		'gengraph1.pl',
		'gengraph2.pl',
		'genmultibar.pl',
		'table_widget1.pl',
		'table_widget2.pl',
		'table_widget3.pl',
		'table_widget4.pl',
		'test_format.pl',
	    'provrml.pl',
		'boundary.pl',
		'dictionary.pl',
		'dictionary_tree.pl',
		'error.pl',
		'field_type.pl',
		'field_value.pl',
		'field_value_check.pl',
		'generator.pl',
		'generator_util.pl',
		'internal_types.pl',
		'io.pl',
		'lookup.pl',
		'parser.pl',
		'parser_util.pl',
		'possible.pl',
		'tokeniser.pl',
                'ddlist.pl',
		'time_analyzer.pl',
	        'gnuplot.pl',
	        'modtester.pl',
                'tester.pl',
%Append
	'Append.pl',
	    'Install.pl',
	    'InstallWin32bin.pl',
	    'BeyondInstall.pl'
	].

fileoption(~mainfile) := '-nobugs'. 
%fileoption(_) := '-noengmods'. 
fileoption(~mainfile) := '-nopatches'.

fileoption(~component) := '-noisoline'.
fileoption(~component) := '-noengmods'.
fileoption(~component) := '-propmods'.
fileoption(~component) := '-nochangelog'.

docformat   := texi.
docformat   := dvi.
docformat   := ps.
docformat   := pdf.
docformat   := ascii.
docformat   := manl.
docformat   := info.
docformat   := infoindex.
docformat   := html.
docformat   := htmlindex.

htmlstyle   := ~atom_concat([~libdir,'/clip.css']).

